poj 3469

2024-05-27 13:58
文章标签 poj 3469

本文主要是介绍poj 3469,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

       这道题是用解决最大流问题的Dinic算法写的,由于题目数据量较大,所以要选择较为高效的算法。

       这道题应该算一种经典的题型,用最小费用将对象分成两个集合的问题,利用最大流最小割定理来解决。通过构图,使得最小费用等于最小割的容量,从而通过最大流算法求出最小割的容量,也即为最小的费用。

       就这道题而言,N个模块作为N个点,与源点有容量为B的弧,与汇点有容量为A的弧,如果a,b两点在不同的CPU核上工作有额外的费用,则在从a连一条容量为w指向b的弧,连一条同样容量由b到a的弧。构好图,接下来就是求最大流最小割的问题。

代码(C++):

#include <cstdlib>
#include <iostream>
#include <queue>
#include <algorithm>#define MAX 20050
#define INF (1<<30)
using namespace std;//#define LOCALstruct Edge{int v;int cap;int next;   
} edge[MAX*10*2*2+MAX*4];int head[MAX],c,level[MAX];void add_edge(int u,int v,int cap)
{edge[c].v=v;edge[c].cap=cap;edge[c].next=head[u];head[u]=c;c++;edge[c].v=u;edge[c].cap=0;edge[c].next=head[v];head[v]=c;c++; 
}void bfs(int s)
{int u,v,i;queue<int> qi;level[s]=0;qi.push(s);while(!qi.empty()){u=qi.front();qi.pop();for(i=head[u];i!=-1;i=edge[i].next){v=edge[i].v;                          if(edge[i].cap>0&&level[v]==-1){               level[v]=level[u]+1;qi.push(v);             }                              }              }
}int dfs(int u,int t,int f)
{int i,v,d,res;if(u==t) return f;res=0;for(i=head[u];i!=-1;i=edge[i].next){v=edge[i].v;                              if(edge[i].cap>0&&level[v]==level[u]+1) {d=dfs(v,t,min(edge[i].cap,f-res));  if(d>0){edge[i].cap-=d;edge[i^1].cap+=d; res+=d;if(res==f) return res;   }               }                             }return res;
}int dinic(int s,int t)
{int flow;flow=0;while(1){memset(level,-1,sizeof(level));bfs(s);if(level[t]==-1) return flow;flow+=dfs(s,t,INF); }
}int main(int argc, char *argv[])
{
#ifdef LOCALfreopen("in.txt","r",stdin);freopen("out.txt","w",stdout);
#endifint n,m,a,b,w,i;while(scanf("%d %d",&n,&m)!=EOF)//超级源点:0    超级汇点:n+1    模块:1~n {c=0;            memset(head,-1,sizeof(head));            for(i=1;i<=n;i++){scanf("%d %d",&a,&b);add_edge(0,i,b);add_edge(i,n+1,a);             } for(i=0;i<m;i++){scanf("%d %d %d",&a,&b,&w);add_edge(a,b,w);add_edge(b,a,w);            }  printf("%d\n",dinic(0,n+1));         }system("PAUSE");return EXIT_SUCCESS;
}

题目( http://poj.org/problem?id=3469):

Dual Core CPU
Time Limit: 15000MS Memory Limit: 131072K
   
Case Time Limit: 5000MS

Description

As more and more computers are equipped with dual core CPU, SetagLilb, the Chief Technology Officer of TinySoft Corporation, decided to update their famous product - SWODNIW.

The routine consists of N modules, and each of them should run in a certain core. The costs for all the routines to execute on two cores has been estimated. Let's define them as Ai and Bi. Meanwhile, M pairs of modules need to do some data-exchange. If they are running on the same core, then the cost of this action can be ignored. Otherwise, some extra cost are needed. You should arrange wisely to minimize the total cost.


Input

There are two integers in the first line of input data, N and M (1 ≤ N ≤ 20000, 1 ≤ M ≤ 200000) .
The next N lines, each contains two integer, Ai and Bi.
In the following M lines, each contains three integers: abw. The meaning is that if module a and module b don't execute on the same core, you should pay extra w dollars for the data-exchange between them.


Output

Output only one integer, the minimum total cost.


Sample Input

3 1
1 10
2 10
10 3
2 3 1000


Sample Output

13

这篇关于poj 3469的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1007674

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i